<template>
  <div>
    <div class="tituloSeccion">
      Consulta su nivel de cumplimiento por periodo de tiempo y nivel geográfico
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
    </div>

    <v-row class="gris">
      <v-col cols="12" md="2">
        <div class="divSelect">
          <div>Año de consulta <span class="tRojo">*</span>:</div>
          <v-select
            :items="anios"
            item-text="anio"
            item-value="anio"
            v-model="filters.anio"
            label="Elige una opción"
            single-line
            @change="getPeriodos"
            solo
            clearable
          >
            <template v-if="$v.filters.anio.$error" v-slot:append-outer>
              <v-popover placement="bottom-end" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <span @click="$v.filters.anio.$reset()" v-close-popover>
                    <span v-if="!$v.filters.anio.required"
                      >¡No te olvides de éste campo!</span
                    >
                  </span>
                </template>
              </v-popover>
            </template>
          </v-select>
        </div>
      </v-col>
      <v-col cols="12" md="2">
        <div class="divSelect" style="white-space: nowrap;">
          <div>Periodo de consulta <span class="tRojo">*</span>:</div>
          <v-select
            :items="periodos"
            item-text="descripcion"
            item-value="numero"
            v-model="filters.periodo"
            label="Elige una opción"
            single-line
            solo
            clearable
            return-object
          >
            <template v-if="$v.filters.periodo.$error" v-slot:append-outer>
              <v-popover placement="bottom-end" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <span @click="$v.filters.periodo.$reset()" v-close-popover>
                    <span v-if="!$v.filters.periodo.required"
                      >¡No te olvides de éste campo!</span
                    >
                  </span>
                </template>
              </v-popover>
            </template>
          </v-select>
        </div>
      </v-col>
      <v-col cols="12" md="2">
        <div class="divSelect">
          <div>Negocio <span class="tRojo">*</span>:</div>
          <v-select
            :items="negocios"
            item-text="descripcion"
            item-value="id_negocio"
            v-model="filters.negocio"
            label="Elige una opción"
            single-line
            solo
            clearable
            return-object
            @change="getNivelesGeograficos"
          >
            <template v-if="$v.filters.negocio.$error" v-slot:append-outer>
              <v-popover placement="bottom-end" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <span @click="$v.filters.negocio.$reset()" v-close-popover>
                    <span v-if="!$v.filters.negocio.required"
                      >¡No te olvides de éste campo!</span
                    >
                  </span>
                </template>
              </v-popover>
            </template>
          </v-select>
        </div>
      </v-col>
      <v-col cols="12" md="2">
        <div class="col6 divSelect">
          <div>Geografía <span class="tRojo">*</span>:</div>
          <v-select
            :items="nivelesGeograficos"
            item-text="descripcion"
            item-value="numero"
            v-model="filters.nivel_geografico"
            label="Elige una opción"
            single-line
            solo
            clearable
            return-object
          >
            <template
              v-if="$v.filters.nivel_geografico.$error"
              v-slot:append-outer
            >
              <v-popover placement="bottom-end" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <span
                    @click="$v.filters.nivel_geografico.$reset()"
                    v-close-popover
                  >
                    <span v-if="!$v.filters.nivel_geografico.required"
                      >¡No te olvides de éste campo!</span
                    >
                  </span>
                </template>
              </v-popover>
            </template>
          </v-select>
        </div>
      </v-col>
      <v-col v-show="filters.nivel_geografico.numero != 4" cols="12" xl="2">
        <div>
          {{ descripcionNivelGeografico }} <span class="tRojo">*</span>:
        </div>
        <div class="divSelect">
          <v-autocomplete
            :items="cecos"
            item-text="descripcion"
            item-value="id_ceco"
            v-model="filters.ceco"
            placeholder="Elige una opción"
            single-line
            :loading="isLoadingCecos"
            solo
            clearable
            persistent-hint
            return-object
            color="primary"
          >
            <template v-if="$v.filters.ceco.$error" v-slot:append-outer>
              <v-popover placement="bottom-end" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <span @click="$v.filters.ceco.$reset()" v-close-popover>
                    <span v-if="!$v.filters.ceco.required"
                      >¡No te olvides de éste campo!</span
                    >
                  </span>
                </template>
              </v-popover>
            </template>
          </v-autocomplete>
        </div>
      </v-col>
      <v-col cols="12" md="2">
        <br />
        <v-btn
          :disabled="isGeneralLoading"
          tile
          depressed
          color="primary"
          @click="search"
          >Generar consulta</v-btn
        >
      </v-col>
    </v-row>
  </div>
</template>
<style scoped>
.tituloSeccion {
  font-size: 16px;
  border-bottom: 2px solid #ffcd13;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
import { required } from "vuelidate/lib/validators";
export default {
  name: "Component-Filtros",
  data() {
    return {
      isFirstLoad: true,
      isLoadingCecos: false,
      anios: [],
      periodos: [],
      negocios: [],
      nivelesGeograficos: [],
      cecos: [],
      disciplina: null,
      finalFilters: {
        numero_periodo: {},
        anio: {},
        id_disciplina: {},
        id_ceco: {},
        id_negocio: {},
        nivel_geografico: {}
      },
      filters: {
        disciplina: {},
        periodo: {},
        anio: {},
        negocio: {},
        nivel_geografico: {},
        ceco: {}
      }
    };
  },
  watch: {
    "filters.nivel_geografico": {
      deep: true,
      handler: function(value, oldValue) {
        this.getCecos();
      }
    }
  },
  validations: {
    filters: {
      periodo: {
        required
      },
      anio: {
        required
      },
      negocio: {
        required
      },
      nivel_geografico: {
        required
      },
      ceco: {
        required: (item, parent) => {
          if (parent.nivel_geografico.numero == 4) {
            return true;
          } else {
            return item != null && parent.nivel_geografico.numero != 4;
          }
        }
      }
    }
  },
  computed: {
    isGeneralLoading() {
      return store.state.isLoading;
    },
    isDisabledGenerarConsulta() {
      return !this.$v.filters.$invalid;
    },
    serviceCommons() {
      return serviceCommons;
    },
    descripcionNivelGeografico() {
      if (this.nivelesGeograficos) {
        let nivelGeografico = this.nivelesGeograficos.filter(
          (itemNivelGeografico) =>
            itemNivelGeografico.numero === this.filters.nivel_geografico.id_ceco
        )[0];
        if (nivelGeografico) {
          return nivelGeografico.descripcion;
        }
      }
      return "Seleccionar Geografía";
    }
  },
  methods: {
    getPeriodoByNumero(numero) {
      let itemPeriodoOut;
      if (this.periodos) {
        this.periodos.forEach((itemPeriodo, indexPeriodo) => {
          if (itemPeriodo.numero === numero) {
            itemPeriodoOut = itemPeriodo;
          }
        });
      }
      return itemPeriodoOut;
    },
    search() {
      this.$v.$touch();
      if (this.isDisabledGenerarConsulta) {
        this.setGlobalFilters();
      }
    },
    attempGenerarConsulta() {
      if (this.isDisabledGenerarConsulta) {
        this.setGlobalFilters();
      }
    },
    getAnios() {
      const self = this;
      axios
        .post(
          "franquicia/dashboard/secure/filter/get/anio/" +
            this.disciplina.id_disciplina
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setAnios(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setAnios(anios) {
      this.anios = anios;
      if (this.anios) {
        anios.forEach((itemAnios) => {
          if (itemAnios.anio == this.disciplina.filtros.anio) {
            this.filters.anio = itemAnios.anio;
          }
        });
        this.getPeriodos();
        this.attempGenerarConsulta();
      }
    },
    getPeriodos() {
      const self = this;
      const filtros = {
        id_frecuencia_medicion: this.disciplina.id_frecuencia_medicion,
        id_disciplina: this.disciplina.id_disciplina
      };
      axios
        .post(
          "franquicia/dashboard/secure/filter/get/periodo/" + this.filters.anio,
          filtros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setPeriodos(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setPeriodos(periodos) {
      this.periodos = periodos;
      if (this.periodos) {
        let periodo_seleccionado = this.getPeriodoByNumero(
          this.disciplina.periodo_seleccionado
        );
        this.filters.periodo = periodo_seleccionado;
        this.attempGenerarConsulta();
      }
    },
    getNegocios() {
      const self = this;
      let service;
      service =
        "franquicia/dashboard/secure/filter/get/negocio/" +
        this.disciplina.id_disciplina;
      axios
        .get(service)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setNegocios(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setNegocios(negocios) {
      this.negocios.push({ id_negocio: 0, descripcion: "Todos" });
      negocios.forEach((itemNegocio) => {
        this.negocios.push(itemNegocio);
      });
      if (this.negocios) {
        this.filters.negocio = this.negocios[0];
        this.attempGenerarConsulta();
        this.getNivelesGeograficos();
      }
    },
    getNivelesGeograficos() {
      const self = this;
      axios
        .get(
          "franquicia/dashboard/secure/filter/get/nivel/geografico/" +
            this.filters.negocio.id_negocio
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setNivelesGeograficos(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setNivelesGeograficos(nivelesGeograficos) {
      this.nivelesGeograficos = nivelesGeograficos;
      if (this.nivelesGeograficos) {
        this.filters.nivel_geografico = this.nivelesGeograficos[0];
        this.getCecos();
        if (this.isFirstLoad) {
          this.attempGenerarConsulta();
          this.isFirstLoad = false;
        }
      }
    },
    getCecos() {
      const self = this;
      this.isLoadingCecos = true;
      this.filters.ceco = null;
      const contentFilters = {
        filtros: {
          descripcion: null,
          id_negocio: this.filters.negocio.id_negocio,
          nivel_geografico: this.filters.nivel_geografico.numero,
          id_disciplina: this.disciplina.id_disciplina,
          anio: this.disciplina.filtros.anio,
          numero_periodo: this.disciplina.filtros.numero_periodo
        }
      };
      axios
        .post(
          "franquicia/dashboard/secure/filter/get/nivel/geografico/hijo/",
          contentFilters
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCecos(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCecos = false;
        });
    },
    setCecos(cecos) {
      if (cecos) {
        cecos = cecos.map((itemCeco) => {
          itemCeco.descripcion =
            itemCeco.id_ceco + " - " + itemCeco.descripcion;
          return itemCeco;
        });
      }
      this.cecos = cecos;
      if (this.filters.tempCecoSearch) {
        this.filters.ceco = {
          id_ceco: "" + this.filters.tempCecoSearch.id_ceco
        };
        this.search();
        this.filters.tempCecoSearch = null;
      }
    },
    setGlobalFilters() {
      this.finalFilters = {
        anio: this.filters.anio,
        numero_periodo: this.filters.periodo.numero_periodo,
        id_negocio: this.filters.negocio.id_negocio,
        id_disciplina: this.disciplina.id_disciplina,
        nivel_geografico: this.filters.nivel_geografico.numero,
        id_ceco: this.filters.ceco ? this.filters.ceco.id_ceco : null,
        descripcion_ceco: this.filters.ceco ? this.filters.ceco.descripcion : ""
      };
      this.filters.disciplina = JSON.parse(JSON.stringify(this.disciplina));
      const filters = {
        final_filters: this.finalFilters,
        filters: this.filters
      };
      this.$root.$emit(
        "searchconsulta",
        JSON.parse(JSON.stringify(filters)),
        this.filters,
        this.zoomSearchCeco
      );
    },
    zoomSearchCeco(ceco) {
      this.filters.tempCecoSearch = ceco;
      this.filters.nivel_geografico = {
        numero: this.finalFilters.nivel_geografico - 1
      };
    }
  },
  destroyed() {
    this.$root.$off("searchconsulta");
  },
  created() {
    if (this.$route.params.disciplina) {
      this.disciplina = this.serviceCommons.base64ToObject(
        this.$route.params.disciplina
      );
    }
    this.getAnios();
    this.getNegocios();
  }
};
</script>
